////////////////////////////////////////////////////////////////////////////////
// Please Don't change the folowing code
////////////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------
// Object Control
//---------------------------------------------------------
function Control(gui)
{
   // This for "IP_Static_Sonos_Script"
   Public_SelectGroup = function(index){
   
      SelectGroup(index);   
   }          
   
   var upnp;
   var servers = [];
   var players = [];
   var disconnected = [];
   var content = [];
   var folder = -1;
   var history = [];
   var groups = [];
   var select = [];   
   var memberselect = [];
   var playselect = [];
   var duration;
   var position = 0;
   var contentxml;
   var current = 0;
   var playlist_total_count = 0;
   
   var server;
   var group;

   var radiocallback;
   var list;
   var grouplist;
   var selected_zone = 0;  
   var volume_group_list;
   var playlist;       
   var memberlist;                            

   var back;
   var play;
   var track;
   var artist;
   var album;
   var art;       
   var volume;
   var percent;
   var mute;
   var zone;
   var shuffle;
   var repeat;
   var timeline;
   var timeleft;
   var timepast;
   var name;
   var letters = [];
   var curletter;
   var favorites;
   var remove;
   
   var radio;
   var deezer;
   
   var updating;
   
   var modes = ["NORMAL", "REPEAT_ALL", "SHUFFLE_NOREPEAT", "SHUFFLE"]; 
   var date = new Date();
   var date2 = new Date();
   
   var group_created = false; // parse data in RecieveEvents only after update group ending 
   var deezer_buffer = ''; // buffer for intermediate Deezer data
   
   var player_volume = 0;

   // Constructor
   Init();
    
   //---------------------------------------------------------
   // Private members access
   //---------------------------------------------------------
   this.GetPlayers = function()
   {
      return players;
   }
  
   //---------------------------------------------------------
   // Initialization
   //---------------------------------------------------------
   function Init()
   {
      // show loading popup while servers loading
      //IR.GetItem(gui.main_page).ShowPopup(gui.loading);
      // Content list
      list = GetItem(gui.content);
      IR.AddListener(IR.EVENT_ITEM_SELECT, list, function (item, subItem)
      {
         if(item > 60000)
         {
            // Search popup
            IR.ShowPopup(gui.search);
         } else
         if(subItem == 5)
         {
            // Select item
            select[item] = select[item] ? 0 : 1;
            list.CreateItem(item, 0, {FillColor: (select[item] ? gui.contentCol1 : gui.contentCol0)});      
            list.CreateItem(item, 5, {Value: select[item]});
                    
            if(folder == 'SQ:' || folder == 'FV:2' /*|| folder.search("S:") >= 0*/)
               GetItem(gui.remove).Visible = IsSelected();               
         } else
         {   
            var selected = content[item];
            var type = selected["upnp:class"].toString();
            
            if(type == "none")
            {
               // do nothing 
            }else 
            if(type == "library")
            {
               server = players[0];
               UpdateContent("A:", "Music Library");
            } else
            if(type == "radio")
            {
               UpdateContent("/Browse.ashx", "Radio");
            }else
            if(type == "deezer")
            {
               UpdateDeezer(selected.itemType, selected.id, selected.title); //"411385351" 
            }
            else if(type == "link")
            {
               UpdateContent(selected["res"], selected["dc:title"]);               
            } 
            else if(type == "linein")
            {
               UpdateContent("AI:", "Line-In");
            } 
            else if(type == "favorites")
            {
               server = players[0];
               UpdateContent("FV:2", "Favorites");
            } 
            else if(type == "playlists")
            {
               server = players[0];
               UpdateContent("SQ:", "Playlists");
            } 
            else if(type == "server")
            {
               // Server select
               server = servers[selected["@id"]];
               UpdateContent(0, server.Description.root.device.friendlyName.toString());
            } 
            else if(type.search("object.container") >= 0)
            {
               // Going in folder
               UpdateContent(selected["@id"], selected["dc:title"]);
            } 
            else if(type == "audio")
            {                 
               /*"x-sonosapi-stream:s37062?sid=254&amp;flags=32"*/
               var s_id = selected.res.indexOf("id=") + 3;
               var uri = "x-sonosapi-stream:" + selected.res.substr(s_id) + "?sid=254&amp;flags=32";
               PlayBack(selected["dc:title"].toString().replace("&", "&amp;"), uri, 1);
               IR.HidePopup("Minus1");
               IR.HidePopup("Minus2");
               // block while buffering
               //IR.GetItem(gui.main_page).ShowPopup(gui.loading);             	
            } else
            {
               // add to queue
               group.parent.InvokeAction("AddURIToQueue", "urn:schemas-upnp-org:service:AVTransport:1", 
               {InstanceID: 0, EnqueuedURI: selected.res, EnqueuedURIMetaData: "", DesiredFirstTrackNumberEnqueued: 0, EnqueueAsNext: true});
               
               // Playback
               var idd = playlist.ItemsCount + 1;
               debug(idd);
               var uri = "x-rincon-queue:" + group.parent.Description.root.device.UDN.toString().substr(5) + "#0";
               group.parent.InvokeAction("SetAVTransportURI", "urn:schemas-upnp-org:service:AVTransport:1", 
               {InstanceID: 0, CurrentURI: uri, CurrentURIMetaData: ""});
               group.parent.InvokeAction("Seek", "urn:schemas-upnp-org:service:AVTransport:1", 
               {InstanceID: 0, Unit: "TRACK_NR", Target: idd});
               if(play.Value == 0)
                  group.parent.InvokeAction("Play", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0, Speed: 1} );
               
               // Playback
               /*var meta = "";
               if(selected.res.indexOf("x-sonosapi-stream:" == 0))
                  meta = '&lt;DIDL-Lite xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns="urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/"&gt;&lt;item id="-1" parentID="-1" restricted="true"&gt;&lt;dc:title&gt;' +
                  selected["dc:title"].toString().replace("&", "&amp;") + '&lt;/dc:title&gt;&lt;desc id="cdudn"&gt;SA_RINCON&lt;/desc&gt;&lt;/item&gt;&lt;/DIDL-Lite&gt;';              
               group.parent.InvokeAction("SetAVTransportURI", "urn:schemas-upnp-org:service:AVTransport:1", 
               {InstanceID: 0, CurrentURI: selected.res.replace("&", "&amp;"), CurrentURIMetaData: meta});
               group.parent.InvokeAction("Play", "urn:schemas-upnp-org:service:AVTransport:1", 
               {InstanceID: 0, Speed: 1});*/               
            }
         }
      });
      
      // Current folder
      name = GetItem(gui.folder);
      
      // Filter of list
      IR.AddListener(IR.EVENT_ITEM_CHANGE, GetItem(gui.filter), function()
      {
         list.Filter = GetItem(gui.filter).Text;
      });
      
      // Back button
      back = GetItem(gui.back);
      IR.AddListener(IR.EVENT_ITEM_PRESS, back, function()
      {
         if(history.length > 1)
         {
            history.pop();
            var prev = history.pop();
            
            if(prev.type == 'Content')
               UpdateContent(prev.id, prev.name);
            else
               UpdateDeezer(prev.type, prev.id, prev.name);
         }   
      });
      
      // Current zone
      zone = GetItem(gui.zone);
      
      // Group list
      grouplist = GetItem(gui.groupList);
      IR.AddListener(IR.EVENT_ITEM_SELECT, grouplist, function(item, subItem)
      {
         // Select group
         SelectGroup(item);
         // Select group members
         if(subItem == 3)
            UpdateMemberList();
      });
      
      // Volume group list
      volume_group_list = GetItem(gui.volume_group_list);
      IR.AddListener(IR.EVENT_ITEM_SELECT, volume_group_list, function (item, subItem)
      {
         switch(subItem)
         {
            case 1: // mute
            {
               var muteval = (players[item].mute_val == 0) ? 1 : 0; 
               players[item].InvokeAction("SetMute", "urn:schemas-upnp-org:service:RenderingControl:1", {InstanceID: 0, Channel: "Master", DesiredMute: muteval});
               break;
            }
            case 3: //minus
               players[item].InvokeAction("SetRelativeVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {InstanceID: 0, Channel: "Master", Adjustment: -5});
               break;
            case 4: // plus
               players[item].InvokeAction("SetRelativeVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {InstanceID: 0, Channel: "Master", Adjustment: 5});
               break;
            default:
               break;
         }
      });
      
      // Group members list
      memberlist = GetItem(gui.memberList);
      IR.AddListener(IR.EVENT_ITEM_SELECT, memberlist, function (item, subItem)
      {
         memberselect[item] ^= 1;
         memberlist.CreateItem(item, 3, {Value: memberselect[item] & 1});
      });
      
      // Regroup button
      IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.memberDone), function()
      {
         Regroup();
      });	       
      
      // Playlist
      playlist = GetItem(gui.playlist);
      IR.AddListener(IR.EVENT_ITEM_SELECT, playlist, function(item, subItem)
      {
         if(subItem == 5)
         {
            // Mark
            playselect[item] ^= 1;
            playlist.CreateItem(item, subItem, {Value: playselect[item]});
            
            // показывает Delete Button, если выбран хотябы один чекбокс и скрывает, если все выключены 
            if(playselect[item] == 1)
            {
               ToggleDeleteButton(true);
            } else
            {
               var some_on = IsPlayListSelected();                     
               ToggleDeleteButton(some_on);
            }
         } else {
            // Playback
            var uri = "x-rincon-queue:" + group.parent.Description.root.device.UDN.toString().substr(5) + "#0";
            group.parent.InvokeAction("SetAVTransportURI", "urn:schemas-upnp-org:service:AVTransport:1", 
               {InstanceID: 0, CurrentURI: uri, CurrentURIMetaData: ""});
            group.parent.InvokeAction("Seek", "urn:schemas-upnp-org:service:AVTransport:1", 
               {InstanceID: 0, Unit: "TRACK_NR", Target: item + 1});
            if(play.Value == 0)
               group.parent.InvokeAction("Play", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0, Speed: 1} );
         }      
      }); 
      
      // Add button
      IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.add), AddToPlaylist);

      // Replace button
      IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.replace), function()
      {
         group.parent.InvokeAction("RemoveAllTracksFromQueue", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0});
         AddToPlaylist();
      });
      
      // Button to save the playlist
      IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.saveOk), function()
      {                  
         if(playlist.ItemsCount > 0)
         {               
            group.parent.InvokeAction("SaveQueue", "urn:schemas-upnp-org:service:AVTransport:1", 
            {InstanceID: 0, Title: GetItem(gui.saveName).Text, ObjectID: ""});
            IR.GetItem(gui.main_page).HidePopup(gui.save);
         } else
         {
            // скрывается много попапов. без SetInterval не работает
            IR.SetTimeout(500, function()
            {
               IR.GetItem(gui.main_page).ShowPopup(gui.warning_popup); /**/
               GetItem(gui.warning_msg).Text = "Add Song to PlayList!";
            });           
         }
      });	       
      GetItem(gui.saveName).Text = "My Playlist";

      // Button to add to favorites
      favorites = GetItem(gui.favorites);
      IR.AddListener(IR.EVENT_ITEM_PRESS, favorites, AddToFavorites); 

      // Button to remove from favorites
      remove = GetItem(gui.remove);
      IR.AddListener(IR.EVENT_ITEM_PRESS, remove, DeleteObjects);

      // Clear button
      IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.clear), function()
      {
         group.parent.InvokeAction("RemoveAllTracksFromQueue", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0});
         artist.Text = "";
         track.Text = "";
         album.Text = "";
         art.GetState(0).Image = "";         
      });
      
      // Delete button
      IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.deleteb), function()
      {
         for(var i = playselect.length-1; i >= 0; --i)
            if(playselect[i])
            {
               group.parent.InvokeAction("RemoveTrackFromQueue", "urn:schemas-upnp-org:service:AVTransport:1", 
               {InstanceID: 0, ObjectID: "Q:0/"+(i+1), UpdateID: 0});
            }
      });	         
      
      // Start playback button
      play = GetItem(gui.play);
      IR.AddListener(IR.EVENT_ITEM_PRESS, play, function()
      {
         if(play.Value == 0)
            group.parent.InvokeAction("Pause", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0} );
         else
            group.parent.InvokeAction("Play", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0, Speed: 1} );
      });
      
      // Next track button
      IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.next), function()
      {
         group.parent.InvokeAction("Next", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0} );
      });
      
      // Previous track button
      IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.previous), function()
      {
         group.parent.InvokeAction("Previous", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0} );
      });
      
      // Track info
      track = GetItem(gui.track);
      artist = GetItem(gui.artist);
      album = GetItem(gui.album);
      art = GetItem(gui.cover);
      
      // Volume level
      percent = GetItem(gui.percent);
      volume = GetItem(gui.volume);
      IR.AddListener(IR.EVENT_ITEM_RELEASE, volume, function()
      {
         var global_vol = volume.Value;      // new global volume value 
         percent.Text = global_vol + '%';
         
         // only one player in group
         if(group.members.length == 0)
         {
            group.parent.InvokeAction("SetVolume", "urn:schemas-upnp-org:service:RenderingControl:1", 
               {InstanceID: 0, Channel: "Master", DesiredVolume: global_vol });
         } else
         {
            // calc new volume for each player
            var mean = CalcGroupVolume(group); // calc old global volume (TODO - можно хранить отдельно)
            // increment of global volume
            var inc_mean = (mean) ? (global_vol / mean) : global_vol;
            // if one of players get maximum other must increments faster
            var aver = CalcAverage(group, inc_mean);
            // calc new value for group parent
            var nvol = CalcNewVol(group.parent.player_volume, inc_mean, aver);
            group.parent.InvokeAction("SetVolume", "urn:schemas-upnp-org:service:RenderingControl:1", 
               {InstanceID: 0, Channel: "Master", DesiredVolume: nvol });
            // and for members
            for(var i = 0; i < group.members.length; ++i)
            {
               nvol = CalcNewVol(group.members[i].player_volume, inc_mean, aver);
               group.members[i].InvokeAction("SetVolume", "urn:schemas-upnp-org:service:RenderingControl:1", 
                  {InstanceID: 0, Channel: "Master", DesiredVolume: nvol });
            }  
         }         
         //GroupInvokeAction("SetVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {InstanceID: 0, Channel: "Master", DesiredVolume: volume.Value});
      });
      
      IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.plus), function()
      {
         GroupInvokeAction("SetRelativeVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {InstanceID: 0, Channel: "Master", Adjustment: 5});
      });
      IR.AddListener(IR.EVENT_ITEM_HOLD, GetItem(gui.plus), function()
      {
         GroupInvokeAction("SetRelativeVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {InstanceID: 0, Channel: "Master", Adjustment: 10});
      });
      IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.minus), function()
      {
         GroupInvokeAction("SetRelativeVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {InstanceID: 0, Channel: "Master", Adjustment: -5});
      });	
      IR.AddListener(IR.EVENT_ITEM_HOLD, GetItem(gui.minus), function()
      {
         GroupInvokeAction("SetRelativeVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {InstanceID: 0, Channel: "Master", Adjustment: -10});
      });
      mute = GetItem(gui.mute);
      IR.AddListener(IR.EVENT_ITEM_PRESS, mute, function()
      {
         GroupInvokeAction("SetMute", "urn:schemas-upnp-org:service:RenderingControl:1", {InstanceID: 0, Channel: "Master", DesiredMute: mute.Value});
      });
      
      // Playback modes
      shuffle = GetItem(gui.shuffle);
      IR.AddListener(IR.EVENT_ITEM_PRESS, shuffle, function()
      {
         var mode = (shuffle.Value << 1) | repeat.Value;
         group.parent.InvokeAction("SetPlayMode", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0, NewPlayMode: modes[mode]});
      });
      
      repeat = GetItem(gui.repeat);
      IR.AddListener(IR.EVENT_ITEM_PRESS, repeat, function()
      {
         var mode = (shuffle.Value << 1) | repeat.Value;
         group.parent.InvokeAction("SetPlayMode", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0, NewPlayMode: modes[mode]});
      }); 
    
      // Playback position
      timeleft = GetItem(gui.timeleft);
      timeline = GetItem(gui.timeline);
      timepast = GetItem(gui.timepast);
      IR.AddListener(IR.EVENT_ITEM_PRESS, timeline, function()
      {
         //timeline.lock = true;
      });	      
      IR.AddListener(IR.EVENT_ITEM_RELEASE, timeline, function()
      {
         //timeline.lock = false;
         position = timeline.Value / 100 * duration;
         var text = "" + Math.floor(position / 3600) + ":" + Math.floor(position % 3600 / 60) + ":" + Math.floor(position % 60);
         group.parent.InvokeAction("Seek", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0, Unit: "REL_TIME", Target: text});
         
      });	      
      
      // Search popup
      var popup = IR.GetPopup(gui.search);
      for(var i = 64; i < 91; i++)
      {
         var item = popup.GetItem(String.fromCharCode(i));
         letters[i] = item;
         IR.AddListener(IR.EVENT_ITEM_PRESS, item, function()
         {
            list.SetPosition(60000 + this.Text.charCodeAt(0));
            IR.GetItem(gui.main_page).HidePopup(gui.search);
         }, item);
      }
      
      // Try to connect
      IR.SetInterval(30000, function()
      {
         for(var i = 0; i < disconnected.length; ++i)         
            disconnected[i].Connect();
         disconnected.length = 0;
      });
      
      // Create UPNP device
      upnp = IR.CreateDevice(IR.DEVICE_UPNP_CONTROL, "UpnpControl");
      upnp.Connect();
      
      // Create browser of radios
      radio = IR.CreateDevice(IR.DEVICE_CUSTOM_HTTP_TCP, "Tunein", "opml.radiotime.com", 80);
      IR.AddListener(IR.EVENT_RECEIVE_TEXT, radio, UpdateRadioCallback);
      //IR.AddListener(IR.EVENT_RECEIVE_TEXT, radio, function(text){
         //IR.Log(text)
         //UpdateRadioCallback();
      //});
      
      // Create browser of radios
      //deezer = IR.CreateDevice(IR.DEVICE_CUSTOM_TCP, "Deezer", "deezer.ws.sonos.com", 80);
      //IR.AddListener(IR.EVENT_RECEIVE_TEXT, deezer, UpdateDeezerCallback);
           
      // Found device listener
      IR.AddListener(IR.EVENT_DEVICE_FOUND, 0, FoundDevice);
 
      // Every cycle function
      IR.AddListener(IR.EVENT_WORK, 0, Work);
      
      // Load players on waking
      //IR.AddListener(IR.EVENT_APP_ENTER_FOREGROUND, 0, LoadPlayers);
    
      // Load players on start
      //LoadPlayers();
      
   }
   
   //---------------------------------------------------------
   // Event: found device
   //---------------------------------------------------------
   function FoundDevice(uuid, url)
   {
      //IR.Log("Device Found = " + uuid + " url = " + url);
      
      
      // Set device parameters
      var host = url.indexOf("http://");
      if(host >= 0)
      {
         host += 7;
         var port = url.indexOf(":", host);
         if(port > 0)
         {
            port += 1;
            var path = url.indexOf("/", port);
            if(path > 0)
            {
				// Create device
			  if(IR.GetDevice(uuid) && IR.GetDevice(uuid).Host == url.substr(host, port - host - 1)) return;
			  var device = IR.CreateDevice(IR.DEVICE_UPNP_DEVICE, uuid);
               device.SetParameters({
                  Host: url.substr(host, port - host - 1), 
                  Port: url.substr(port, path - port), 
                  DescriptionUrl: url.substr(path)});
               device.Connect();
               
               // Event: device connected
               IR.AddListener(IR.EVENT_ONLINE, device, function()
               {                  
                  var xml = this.Description.root.device;
                  var type = xml.deviceType.toString();

                  //IR.Log("Device Connect = " + xml.friendlyName.toString() + " type = " + type);
                                    
                  // If server
                  if(type.indexOf("urn:schemas-upnp-org:device:MediaServer") >= 0)
                  {
                     servers.push(this);
                     if(folder == -1) 
                     {
                        back.Visible = false;
                        history.length = 0;
                        UpdateContent(folder, "Music Sources");
                     }
                  }
                  // If player
                  if(type.indexOf("urn:schemas-upnp-org:device:ZonePlayer") >= 0 && xml.modelNumber.toString().indexOf("ZB") < 0)
                  {
                     players.push(this);
                     SavePlayers();
           
                     // Subscribe to device events                   
                     
                     // Update groups list
                     UpdateGroups();
                     IR.AddListener(IR.EVENT_RECEIVE_EVENT, this, ReceiveEvent, this);
                     Subscribe(this);
                     // Update content list
                     if(folder == -1) 
                     {
                        back.Visible = false;                           
                        history.length = 0;
                        UpdateContent(folder, "Music Sources");
                     }
                  }
               }, device);         

               // Event: device disconnected
               IR.AddListener(IR.EVENT_OFFLINE, device, function()
               {
                  //IR.Log("Device Offline = " + this.Name);
                  var i;
                  // Remove from servers list
                  for(i = 0; i < servers.length; ++i)
                     if(servers[i] == this)
                     {
                        servers.splice(i, 1);
                        if(folder == -1) 
                        {
                           back.Visible = false;
                           history.length = 0;
                           UpdateContent(folder, "Music Sources");
                        }                           
                        break;
                     }
                  
                  // Remove from players list
                  for(i = 0; i < players.length; ++i)
                     if(players[i] == this)
                     {
                        players.splice(i, 1);
                        // Update groups list
                        UpdateGroups();
                        if(folder == -1) 
                        {
                           back.Visible = false;
                           // Sergey added
                           up_icon = GetItem(gui.up_icon);
                           up_icon.Visible = true;
                          
                           history.length = 0;
                           UpdateContent(folder, "Music Sources");
                        }                           
                        break;
                     }
                     
                  // Add to disconnected
                  disconnected.push(this);
                  
               }, device);
            }
         }
      }  
   }
      
   //---------------------------------------------------------
   // Update content list
   //---------------------------------------------------------
   function UpdateContent(nfolder, nname)
   {
      var i, xml, response, items, item, id;
      
      folder = nfolder;

      // Save history
      history.push({type: 'Content', id: folder, name: nname});

      // Clear filter
      GetItem(gui.filter).Text = "";
      list.Filter = "";
      
      // Disable all search letters
      for(i = 64; i < 91; i++)
         letters[i].Enable = false;
      curletter = undefined;
         
      content.length = 0;
      select.length = 0;
      list.Clear();
      name.Text = nname;
      remove.Visible = false;
      favorites.Visible = true;

      if(folder == -1)
      {
         id = 0;
         back.Visible = false;
         // Sonos library
         if(players.length)
         {
            content[id] = {"@id": 0, "upnp:class":  "library"};
            list.CreateItem(id, 2, {Text: "Music Library"});
            list.CreateItem(id, 2, {Name: "Music Library"});
            list.CreateItem(id, 4, {Image: "Folder.png"});
            list.CreateItem(id, 5, {Opacity: 0});
            id++;
         }
         // Radio
         content[id] = {"@id": 0, "upnp:class":  "radio"};
         list.CreateItem(id, 2, {Text: "Radio"});
         list.CreateItem(id, 2, {Name: "Radio"});
         list.CreateItem(id, 4, {Image: "Folder.png"});
         list.CreateItem(id, 5, {Opacity: 0});
         id++;
         // Deezer
         /*content[id] = {"@id": 0, "upnp:class":  "deezer", 'title': 'Deezer', 'id': 'root'};
         list.CreateItem(id, 2, {Text: "Deezer"});
         list.CreateItem(id, 2, {Name: "Deezer"});
         list.CreateItem(id, 4, {Image: "Folder.png"});
         list.CreateItem(id, 5, {Opacity: 0});
         id++;*/
         // LineIn
         content[id] = {"@id": 0, "upnp:class":  "linein"};
         list.CreateItem(id, 2, {Text: "Line-In"});
         list.CreateItem(id, 2, {Name: "Line-In"});
         list.CreateItem(id, 4, {Image: "Folder.png"});
         list.CreateItem(id, 5, {Opacity: 0});
         id++;
         // Favorites
         content[id] = {"@id": 0, "upnp:class":  "favorites"};
         list.CreateItem(id, 2, {Text: "Favorites"});
         list.CreateItem(id, 2, {Name: "Favorites"});
         list.CreateItem(id, 4, {Image: "Folder.png"});
         list.CreateItem(id, 5, {Opacity: 0});
         id++;
         // Playlists
         content[id] = {"@id": 0, "upnp:class":  "playlists"};
         list.CreateItem(id, 2, {Text: "Sonos Playlists"});
         list.CreateItem(id, 2, {Name: "Playlists"});
         list.CreateItem(id, 4, {Image: "Folder.png"});
         list.CreateItem(id, 5, {Opacity: 0});
         id++;
         // Media servers
         for(i = 0; i < servers.length; ++i) 
         {
            xml = servers[i].Description.root.device;
            list.CreateItem(id, 2, {Text: xml.friendlyName.toString()});
            list.CreateItem(id, 0, {Name: xml.friendlyName.toString()});
            list.CreateItem(id, 4, {Image: "Server.png"});
            list.CreateItem(id, 5, {Opacity: 0});
            content[id] = { "@id": i, "upnp:class":  "server" };
            id++;
         }
      } else
      if(folder.toString().indexOf("/") == 0)
      {
         // Wait popup
         back.Visible = false;
         IR.GetItem(gui.main_page).ShowPopup(gui.waitleft);
         // Radio catalog
         radio.Send(['GET,' + folder + ',']);
         // Response time limit
         IR.SetTimeout(5000, function()
         {
            IR.GetItem(gui.main_page).HidePopup(gui.waitleft);
            back.Visible = true;
         });
      } else
      if(folder == "AI:")
      {
         // Line In
         var num = players.length;
         
         for(var i = 0; i < num; ++i) 
         {
            // Wait popup
            back.Visible = false;
            IR.GetItem(gui.main_page).ShowPopup(gui.waitleft);
            // LineIn devices request
            players[i].InvokeAction("Browse", "urn:schemas-upnp-org:service:ContentDirectory:1",
            { ObjectID: folder, BrowseFlag: "BrowseDirectChildren", Filter: "", StartingIndex: 0, RequestedCount: 10, SortCriteria: "" }, 
            function(index) 
            {
               return function(text)
               {
                  try {
                     xml = new XML(text);               
                     items = xml["s:Envelope"]["s:Body"]["u:BrowseResponse"]["Result"]["DIDL-Lite"]["item"];
                     id = content.length;
                     
                     i = 0;
                     while(item = items[i++])
                     {
                        title = item["dc:title"].toString() + ": " + players[index].Description.root.device.roomName.toString();
                        list.CreateItem(id, 2, {Text: title});                     
                        list.CreateItem(id, 5, {Visible: false, Enable: false});
                        // Data
                        content[id++] = {"@id":         item["@id"].toString(), 
                                         "upnp:class":  item["upnp:class"].toString(), 
                                         "dc:title":    title,
                                         "res":         item.res ? item.res.toString() : ""};
                     }
                  } catch(error) {}                  

                  // The data from all sources received
                  if(--num == 0)
                  {
                     IR.GetItem(gui.main_page).HidePopup(gui.waitleft);
                     back.Visible = true;                     
                  } 
               }
            }(i));         
         }      
      } else
      {
         // Favorites
         //remove.Visible = (folder == "FV:2" || folder == "SQ:");
         favorites.Visible = !remove.Visible;
         // Wait popup
         back.Visible = false;
         IR.GetItem(gui.main_page).ShowPopup(gui.waitleft);
         // Browse request
         server.InvokeAction("Browse", "urn:schemas-upnp-org:service:ContentDirectory:1",
         { ObjectID: folder, BrowseFlag: "BrowseDirectChildren", Filter: "dc:title,res", StartingIndex: 0, RequestedCount: 100, SortCriteria: "" }, 
         UpdateContentCallback);      
      }
   }
   
   //---------------------------------------------------------
   // Update content callback
   //---------------------------------------------------------
   function UpdateContentCallback(text)
   {
      try 
      {
         var i, xml, response, items, item, id, title, find;
         
         //IR.Log("Browse result = " + text);
         // Create XML from text
         xml = new XML(text);
      
         if(xml["s:Envelope"] != undefined)
            response = xml["s:Envelope"]["s:Body"]["u:BrowseResponse"];
         else
            response = xml["SOAP-ENV:Envelope"]["SOAP-ENV:Body"]["m:BrowseResponse"];
            
         // If need search letters
         switch(folder)
         {
         case "A:ALBUM":
         case "A:COMPOSER":
         case "A:GENRE":
         case "A:ALBUMARTIST":
         case "A:TRACKS":
            find = true;
            break;
         default:
            find = false;
            break;
         }
            
         // Folders
         id = content.length;
         items = response["Result"]["DIDL-Lite"]["container"];
         if(items != undefined)
         {
            i = 0;
            while(item = items[i++])
            {
               var l_artist = "";
               title = item["dc:title"].toString();
               if(item["dc:creator"])
                  l_artist = item["dc:creator"].toString();
                  
               if(find) CreateFindLetter(title);
                              
               if(folder == "A:")
                  list.CreateItem(id, 5, {Visible: false, Enable: false});               
               // Element
               list.CreateItem(id, 2, { Text:  title});
               list.CreateItem(id, 0, { Name:  title});
               list.CreateItem(id, 4, { Image: "Folder.png"});
               list.CreateItem(id, 3, { Text:   l_artist});
                 
               // Data
               content[id++] = {
                                "@id":         item["@id"].toString(), 
                                "upnp:class":  item["upnp:class"].toString(), 
                                "dc:title":    title,
                                "res":         item.res ? item.res.toString() : "",
                                };
            }
         }
         
         // Songs
         items = response["Result"]["DIDL-Lite"]["item"];				
         if(items != undefined)
         {
            i = 0;
            while(item = items[i++])
            {
               title = item["dc:title"].toString();
               if(find) CreateFindLetter(title);

               // Element
               list.CreateItem(id, 2, {Text: title});
               list.CreateItem(id, 0, {Name: title}); 
               
               var upnp_class = item["upnp:class"].toString();
               var item_id = item["@id"].toString();

               try {
                  if(item["r:resMD"])
                  {
                     var xml_MD = new XML(item["r:resMD"].toString());
                     upnp_class = xml_MD["DIDL-Lite"]["item"]["upnp:class"];
                     item_id = xml_MD["DIDL-Lite"]["item"]["@id"];
                  }
               } catch(error) { debug('Catch xml error while get r:resMD. ' + error ); }
                  
               // Data
               content[id++] = {"@id":         item_id, 
                                "upnp:class":  upnp_class, 
                                "dc:title":    title,
                                "res":         item.res ? item.res.toString() : "",
                                };
            }
         }
         
         if(id < response.TotalMatches)
         {
            // Request remaining
            server.InvokeAction("Browse", "urn:schemas-upnp-org:service:ContentDirectory:1",
            { ObjectID: folder, BrowseFlag: "BrowseDirectChildren", Filter: "dc:title,res", StartingIndex: id, RequestedCount: 100, SortCriteria: "" }, 
            UpdateContentCallback);
         } else 
         {
            IR.GetItem(gui.main_page).HidePopup(gui.waitleft);
            back.Visible = true;
         }
      } catch(error) 
      {
         // Hide popup if catch exception
         IR.GetItem(gui.main_page).HidePopup(gui.waitleft);
         back.Visible = true;
         //IR.Log("UpdateContent Exception!");
      }
   }
   
   //---------------------------------------------------------
   // Search letter
   //---------------------------------------------------------
   function CreateFindLetter(title)
   {
      // Letter
      var letter = title.charAt(0).toUpperCase();
      var code = letter.charCodeAt(0);
      
      if(!curletter && (code < 65 || code > 90))
      {
         letters[64].Enable = true;
         curletter = 60064;
         list.CreateItem(curletter, 0, {Name: "@"});
         list.CreateItem(curletter, 6, {Visible: true, Enable: true, Text: "@"});
         list.CreateItem(curletter, 5, {Visible: false, Enable: false});                     
      } else               
      if(curletter != letter && code >= 65 && code < 91)
      {
         letters[code].Enable = true;
         curletter = code + 60000;
         list.CreateItem(curletter, 0, { Name:  letter});
         list.CreateItem(curletter, 6, {Visible: true, Enable: true, Text: letter});
         list.CreateItem(curletter, 5, {Visible: false, Enable: false});
      }
   }
   
   //---------------------------------------------------------
   // Update radio callback
   //---------------------------------------------------------
   function UpdateRadioCallback(text)
   {
   if (/\<\?xml version\=\"1\.0\" encoding\=\"UTF\-8\"\?\>/.test(text)) {
				radiocallback = text;
				if (text.indexOf("</opml>") == -1) {
					return;
				}
			} else {
				if (text.indexOf("</opml>") != -1) {
					radiocallback += text;
				} else {
					radiocallback += text;
					return;
				}
			}
      try 
      {
         var i, 
             j, 
             xml, 
             items, 
             item, 
             title, 
             type, 
             res, 
             sitems, 
             sitem;
         
         //IR.Log("Radio XML = " + text);
         // Create XML from text
         xml = new XML(radiocallback);
         radiocallback = undefined;
         items = xml.opml.body.outline;
         id = content.length;
         
         i = 0;
         
         while(item = items[i++])
         {
            title = item["@text"].toString();
            list.CreateItem(id, 2, { Text: title});
            list.CreateItem(id, 5, {Visible: false, Enable: false});
            
            if(item["@type"])
            {
               type = item["@type"].toString();

               // Element
               list.CreateItem(id, 0, { Name:  title});
               if(type == "link")
               {
                  // Folder
                  list.CreateItem(id, 4, { Image: "Folder.png"});
                  res = item["@URL"].toString().substr(25);
               } else 
               {
                  // Stream
                  res = "x-rincon-mp3radio" + item["@URL"].toString().substr(4).replace("&", "&amp;");
               }
               content[id++] = {"upnp:class":   type, 
                                "dc:title":     title,
                                "res":          res};
               
            } else
            {
               // Subtitle
               list.CreateItem(id, 0, { Name:  title, Enable: false, FillColor: gui.contentCol1});
               list.CreateItem(id, 4, {Visible: false, Enable: false});
               id++;

               // Subelement
               sitems = item.outline;
               j = 0;
               while(item = sitems[j++])
               {
                  title = item["@text"].toString();
                  list.CreateItem(id, 2, { Text: title});
                  list.CreateItem(id, 5, {Visible: false, Enable: false});
                  type = item["@type"].toString();

                  // Element
                  list.CreateItem(id, 0, { Name:  title});
                  if(type == "link")
                  {
                     // Folder
                     list.CreateItem(id, 4, { Image: "Folder.png"});
                     res = item["@URL"].toString().substr(25); 
                  } else 
                  {
                     // Stream
                     res = "x-rincon-mp3radio" + item["@URL"].toString().substr(4).replace("&", "&amp;");
                  }
                  if(type != ""){
                  content[id++] = {"upnp:class":   type, 
                                   "dc:title":     title,
                                   "res":          res};
                                   }
               }
            }          
         }
         
         IR.HidePopup(gui.waitleft);
         back.Visible = true;
      } catch(error) 
      {
         // Hide popup if catch exception
         IR.HidePopup(gui.waitleft);
         back.Visible = true;
         IR.Log("UpdateRadioCallback Exception!");
      }
   }
   
   /*
      Parse data recieved from Deezer
   */
   function UpdateDeezerCallback(text)
   {
      debug(text);
      try
      {
         var item, count, response;
         var packet_start = text.indexOf('<s:Envelope');
         //debug('packet_start ' + packet_start);    
         text = text.substring(packet_start);
                 
         var xml = new XML(deezer_buffer + text);
         
         response = xml["s:Envelope"]["s:Body"]["ns:getMetadataResponse"];
         
         if(response)
            response = response['ns:getMetadataResult'];
         
         count = response['ns:count'];
         
         if(count)
         {
            item = response['ns:mediaCollection'];
            list.Clear();
         }
            
         for(var id = 0; id < count; id++)
         { 
            content[id] = {'upnp:class':  'deezer',
                           'id':          item[id]['ns:id'].toString(), 
                           'itemType':    item[id]['ns:itemType'].toString(),
                           'title':       item[id]['ns:title'].toString(),};
            
            list.CreateItem(id, 2, { Text: content[id].title});
            list.CreateItem(id, 5, { Visible: false, Enable: false});
            
            var art = item[id]['ns:albumArtURI'];
            
            if(art) {
               //debug(art.toString());
               list.CreateItem(id, 4, { Image: art.toString()});
            } else
               list.CreateItem(id, 4, { Image: 'Folder.png'});
         }
         
         //type = 'deezer';
         IR.GetItem(gui.main_page).HidePopup(gui.waitleft);
         back.Visible = true;
         deezer_buffer = '';
      } catch(error) 
      {
         list.Clear();
         IR.GetItem(gui.main_page).HidePopup(gui.waitleft);
         back.Visible = true;
         IR.Log("UpdateDeezerCallback Exception! " + error);
         deezer_buffer += text;
      }
   }
   
   /*
      Navigate Deezer
   */
   function UpdateDeezer(itemType, id, title)
   {
      var request;
      // Wait popup
      back.Visible = false;
      IR.GetItem(gui.main_page).ShowPopup(gui.waitleft);
            
      // Deezer catalog
      switch(itemType)
      {
         case undefined:
         case 'favorites':
         case 'container':
         case 'genre':
         case 'artist':
            request = FormInvokeAction('POST', '/services/smapi', 'deezer.ws.sonos.com', 'getMetadata', id);
            deezer.Send(request);
            history.push({type: itemType, id: id, name: title});
            name.Text = title;
            break;
         case 'program':
            var uri = 'x-sonosapi-radio:' + id.replace(/:/g, '%3a') + '?sid=2&amp;flags=76';
            PlayBack(title, uri, 1);
            break;
         default:
            debug('UpdateDeezer default ' + itemType);
            break;
      }               
      // Response time limit
      IR.SetTimeout(5000, function()
      {
         IR.GetItem(gui.main_page).HidePopup(gui.waitleft);
         back.Visible = true;
      });
   }
    
   //---------------------------------------------------------
   // Update playlist
   //---------------------------------------------------------
   function UpdatePlaylist()
   {
      if(!updating)
      {
         updating = true;
         playlist.Clear();
         playselect.length = 0;
         
         // Wait popup
         IR.GetItem(gui.main_page).ShowPopup(gui.waitright);
         
         // Request playlist
         group.parent.InvokeAction("Browse", "urn:schemas-upnp-org:service:ContentDirectory:1",
         { ObjectID: "Q:0", BrowseFlag: "BrowseDirectChildren", Filter: "dc:title,dc:creator", StartingIndex: 0, RequestedCount: 100, SortCriteria: "" }, 
         UpdatePlaylistCallback);
      }
   }   
   
   //---------------------------------------------------------
   // Update playlist callback
   //---------------------------------------------------------
   function UpdatePlaylistCallback(text)
   {
      //IR.Log("UpdatePlaylistCallback result = " + text);
      var xml = new XML(text);
      // Fill playlist
      var response = xml["s:Envelope"]["s:Body"]["u:BrowseResponse"];      
      var items = response["Result"]["DIDL-Lite"]["item"];
      var id = playlist.ItemsCount;
      if(items != undefined)
      {
         var url = "http://" + group.parent.Host + ":" + group.parent.Port;
         var i = 0;
         while(item = items[i])
         {
            playlist.CreateItem(id, 2, {Text: item["dc:title"].toString() });
            if(item["dc:creator"]) playlist.CreateItem(id, 3, {Text: item["dc:creator"].toString() });
            playlist.CreateItem(id, 4, {Image: url + item["upnp:albumArtURI"].toString() });
            ++i;
            ++id;
         }
         
         playlist_total_count = i;
      }
     
      if(id < response.TotalMatches)
      {
         // Request remaining
         group.parent.InvokeAction("Browse", "urn:schemas-upnp-org:service:ContentDirectory:1",
         { ObjectID: "Q:0", BrowseFlag: "BrowseDirectChildren", Filter: "dc:title,dc:creator", StartingIndex: id, RequestedCount: 100, SortCriteria: "" }, 
         UpdatePlaylistCallback);            
      } else 
      {
         updating = false;
         IR.GetItem(gui.main_page).HidePopup(gui.waitright);
         IR.GetItem(gui.main_page).HidePopup(gui.loading);
         // Current track
         if(current > 0 && current <= playlist.ItemsCount) 
         {
            playlist.CreateItem(current-1, 0, {FillColor: gui.playlistCol1});
         } else { 
            current = 0;
         }
         // отображение количества песен в плейлисте
         GetItem(gui.count).Text = current + " of " + playlist_total_count;
      }
   }

   //---------------------------------------------------------
   // Update groups list
   //---------------------------------------------------------
   function UpdateGroups()
   {
      var info = [];
      var num = players.length;
      grouplist.Clear();
      volume_group_list.Clear();
      
      for(var i = 0; i < num; ++i) 
      {
         group_created = false;
         // Receiving meta data
         players[i].InvokeAction("GetMediaInfo", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0}, function(index)
         {
            return function(text)
            {
               // Save info and wait for all data
               var xml = new XML(text);
               info[index] = xml["s:Envelope"]["s:Body"]["u:GetMediaInfoResponse"]["CurrentURI"].toString();
               
               // If received all data, create a groups
               if(--num == 0)
               {
                  // Create groups
                  group = undefined;
                  zone.Text = "";
                  groups.length = 0;
                  
                  for(i = 0; i < info.length; ++i)
                  {
                     if(!info[i] || info[i].indexOf("x-rincon:") < 0)
                     {
                        players[i].group = undefined;
                        
                        var ngroup = {parent: players[i], 
                                      members: [], 
                                      name: players[i].Description.root.device.roomName.toString(),
                                      uri: "x-rincon:" + players[i].Description.root.device.UDN.toString().substr(5)};
                                      
                        groups.push(ngroup);
                        // Add members
                        for(var j = 0; j < info.length; ++j)
                        {
                           if(info[j] == ngroup.uri)
                           {
                              ngroup.members.push(players[j]);
                              ngroup.name += ", " + players[j].Description.root.device.roomName;
                              players[j].group = ngroup;
                           }

                           volume_group_list.CreateItem(j, 2, {Text: players[j].Description.root.device.roomName.toString()});
                        }
                     }
                  }
                  // Update list
                  //grouplist.Clear();                  
                  for(i = 0; i < groups.length; ++i) {
                     grouplist.CreateItem(i, 4, {Text: groups[i].name});
                  }
                  group_created = true;

                  for(i in players) {
                     UnSubscribe(players[i]);
                     Subscribe(players[i]);
                  } 
                  // Select first group default
                  SelectGroup(selected_zone);
               }
            }
         }(i));         
      }      
   }
   
   //---------------------------------------------------------
   // Update group members list
   //---------------------------------------------------------
   function UpdateMemberList()
   {
      memberlist.Clear();
      memberselect.length = 0;
      for(var i = 0; i < players.length; ++i) 
      {
         memberlist.CreateItem(i, 1, {Text: players[i].Description.root.device.roomName.toString()});
         var check = (players[i] == group.parent);
         for(var j = 0; j < group.members.length && !check; ++j)
            check = (players[i] == group.members[j]);
         if(check) 
         {
            memberlist.CreateItem(i, 3, {Value: 1});
            memberselect[i] = 3;
         }
      }
   }
   
   //---------------------------------------------------------
   // Regroup members
   //---------------------------------------------------------
   function Regroup()
   {
      var parentUri = "x-rincon:" + group.parent.Description.root.device.UDN.toString().substr(5);
      
      for(var i = 0; i < players.length; ++i) 
      {
         var old = memberselect[i] >> 1;
         if(memberselect[i] & 1)
         {
            // Add to group
            if(!old)
            {
               ToggleOpenVolumeGroup(true);
               players[i].InvokeAction("SetAVTransportURI", "urn:schemas-upnp-org:service:AVTransport:1", 
               {InstanceID: 0, CurrentURI: parentUri, CurrentURIMetaData: ""});
            }
         } else if(old)
         {
            ToggleOpenVolumeGroup(false);
            // Remove from group
            players[i].InvokeAction("BecomeCoordinatorOfStandaloneGroup", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0});
         }
      }         
   } 

   //---------------------------------------------------------
   // Select group
   //---------------------------------------------------------
   function SelectGroup(index)
   {      
      if(groups.length == 0)
      {
         debug('groups.length == 0');
         return;
      }
      
      if(index >= groups.length)
      {
         debug(index +' >= ' + groups.length);
         selected_zone = 0;
         index = 0;
      }
         
      HighLightSelectedZone(index);
         
      group = groups[index];
      zone.Text = group.name;
      // Re-subscribe to the events to get the current status of player
      UnSubscribe(group.parent);         
      Subscribe(group.parent);   
      
      ToggleOpenVolumeGroup(group.members.length > 0);
   }
   
   
   //---------------------------------------------------------
   // Add selected to playlist
   //---------------------------------------------------------
   function AddToPlaylist()
   {
      for(var i = 0; i < select.length; ++i)
      {
         if(select[i])
         {
            //var meta = "&lt;DIDL-Lite xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&quot;&gt;&lt;item id=&quot;{CE5F8221-FB6A-45E1-AFDF-B30068216433}.0.E46BFA30&quot; &gt;&lt;desc id=&quot;cdudn&quot; nameSpace=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot;&gt;f90bba79-e8e9-430b-8146-0f48ec6bad60&lt;/desc&gt;&lt;/item&gt;&lt;/DIDL-Lite&gt;";
            //IR.Log("res=" + content[i].res);
            group.parent.InvokeAction("AddURIToQueue", "urn:schemas-upnp-org:service:AVTransport:1", 
            {InstanceID: 0, EnqueuedURI: content[i].res, EnqueuedURIMetaData: "", DesiredFirstTrackNumberEnqueued: 0, EnqueueAsNext: true});
            // Clear selection
            list.CreateItem(i, 0, {FillColor: gui.playlistCol0});
            list.CreateItem(i, 5, {Value: 0});                  
         }
      }
      select.length = 0;
      //UpdatePlaylist();
   }  
   
   //---------------------------------------------------------
   // Add selected to favorites
   //---------------------------------------------------------
   function AddToFavorites()
   {
      for(var i = 0; i < select.length; ++i)
      {
         if(select[i])
         {
            var elements = "&lt;DIDL-Lite xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot; xmlns:r=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot; xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&quot;&gt;&lt;item&gt;" + 
               "&lt;dc:title&gt;" + content[i]["dc:title"] + "&lt;/dc:title&gt;" +
               "&lt;res protocolInfo=&quot;x-file-cifs:*:audio/mpeg:*&quot;&gt;" + content[i].res + "&lt;/res&gt;" +
               "&lt;r:resMD&gt;&amp;lt;DIDL-Lite&amp;gt;&amp;lt;/DIDL-Lite&amp;gt;&lt;/r:resMD&gt;&lt;/item&gt;&lt;/DIDL-Lite&gt;"      
            group.parent.InvokeAction("CreateObject", "urn:schemas-upnp-org:service:ContentDirectory:1", 
            {ContainerID: "FV:2", Elements: elements});
            // Clear selection
            list.CreateItem(i, 0, {FillColor: gui.contentCol0});
            list.CreateItem(i, 5, {Value: 0});                  
         }
      }
      select.length = 0;
   }  

   //---------------------------------------------------------
   // Delete selected objects
   //---------------------------------------------------------
   function DeleteObjects()
   {      
      if(select.length == 0)
      {
         // remove поумолчанию невидим, соединить его с иконокой TODO
         IR.GetItem(gui.main_page).ShowPopup(gui.warning_popup);
         GetItem(gui.warning_msg).Text = "Plese select songs for delete"; 
      }   
         
      for(var i = 0; i < select.length; ++i)
      {
         if(select[i])
         {
            group.parent.InvokeAction("DestroyObject", "urn:schemas-upnp-org:service:ContentDirectory:1", 
            {ObjectID: content[i]["@id"]});
         }
      }
      
      // Update list
      IR.SetTimeout(500, function()
      {
         var folder = history.pop();
         UpdateContent(folder.id, folder.name);
      });
   }  
   
   //---------------------------------------------------------
   // Event: UPNP event
   // in this - device
   //---------------------------------------------------------
   function ReceiveEvent(type, text)
   {
      //IR.Log("Event room = " + this.Description.root.device.roomName);
      //IR.Log("Event service = " + type);
      //IR.Log("Event text = " + text);
      //IR.GetItem(gui.main_page).HidePopup(gui.waitleft);
      var xml = new XML(text);
      // Monitor changes in the groups
      try {
         var uri = xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID.CurrentTrackURI["@val"];
         if((this.group  && this.group.uri != uri) || 
            (!this.group && uri.indexOf("x-rincon:") >= 0))
            UpdateGroups();
      } catch(error) {}
      // Volume
      try {
         var volume_val = xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID.Volume["@val"];
         try {
					volume_group_list.CreateItem(GetPlayerIndex(this), 7, {
						Text: l_volume_val + "%"
					});
				} catch (e) {
				}
         // save volume to players[i]
         this.player_volume = parseInt(volume_val);
         
         var group_vol = CalcGroupVolume(group);
         volume.Value = group_vol;
         percent.Text = group_vol + '%';
         
      } catch(error) {}
      // Mute
      try {
         var mute_val = xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID.Mute["@val"];
         // создаем параметр объекту
         this.mute_val = mute_val;

         //volume_group_list.CreateItem(GetPlayerIndex(this), 1, {Value: mute_val});
         
         if(group && group.parent == this)
            mute.Value = mute_val;
         
      } catch(error) {}
      // Track, Artist, Album
      try {
         var track_data = xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID.CurrentTrackMetaData;
         var xml2 = new XML(track_data["@val"]);
         xml2 = xml2["DIDL-Lite"];
         if(xml2)
         {        
            if(group)
            {
               var gr_indx = GetGroupIndex(this);
               
               if(gr_indx) {
                  xml2 = xml2.item;
                  var l_track = (xml2["dc:title"]) ? xml2["dc:title"].toString() : "";
                  var l_artist = (xml2["dc:creator"]) ? xml2["dc:creator"].toString() : "";
                  var l_album = (xml2["upnp:album"]) ? xml2["upnp:album"].toString() : "";
                 
                  if(xml2["r:streamContent"].toString()) 
                     l_track = xml2["r:streamContent"];
                                     
                  //grouplist.CreateItem(gr_indx, 8, {Text: l_track});
                  //grouplist.CreateItem(gr_indx, 7, {Text: l_artist});
                  //grouplist.CreateItem(gr_indx, 9, {Text: l_album});
               }
            }
            if(group && group.parent == this)
            {
               track.Text = l_track;
               artist.Text = l_artist;
               album.Text = l_album;
                                    
               var l_uri = xml2["upnp:albumArtURI"];
               art.GetState(0).Image = (l_uri) ? "http://" + group.parent.Host + ":" + group.parent.Port + l_uri : "Song_no_cover_big.png";
            }
         }
                 
      } catch(error) {}
      // Play, Pause, Stopped
      try {
         var tr_state = xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID.TransportState["@val"];
         var tr_val = 2; // Stop ???
          
         switch(tr_state) {
            case "PLAYING":tr_val = 0;break;
            case "PAUSED_PLAYBACK":tr_val = 1;break;
            case "STOPPED": 
               tr_val = 1;
               timeleft.Text = '0:00:00';
               timepast.Text = '0:00:00';
               break;
            default:
            {
               tr_val = 2;               
               break;
            }
         }
         
         if(group && group_created == true)
         {  
             var gr_indx = GetGroupIndex(this);
             //debug("group " + group + " gr_indx " + gr_indx );
             if(gr_indx) {
               grouplist.CreateItem(gr_indx, 6, {Value: tr_val});
             }                           
         }
            
         if(group && group.parent == this)
            play.Value = (tr_state == "PLAYING") ? 1 : 0;
      } catch(error) {}
      
      // Changes in current group
      if(group && group.parent == this)
      {  
         if(type == "urn:schemas-upnp-org:service:ContentDirectory:1")
         {
            UpdatePlaylist();
         } else 
         {
            try {
                var vars;
                //if(xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID)
                {
                vars = xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID;
               if(vars.TransportState)
               {
                  play.Value = (vars.TransportState["@val"] == "PLAYING") ? 1 : 0;
               }
               if(vars.CurrentPlayMode)
               {
                  // TODO may be use map?
                  switch(vars.CurrentPlayMode["@val"])
                  {
                  case "NORMAL":
                     shuffle.Value = 0;
                     repeat.Value = 0;
                     break;
                  case "REPEAT_ALL":
                     shuffle.Value = 0;
                     repeat.Value = 1;
                     break;
                  case "SHUFFLE_NOREPEAT":
                     shuffle.Value = 1;
                     repeat.Value = 0;
                     break;
                  case "SHUFFLE":
                     shuffle.Value = 1;
                     repeat.Value = 1;
                     break;
                  }
               }
               if(vars.CurrentTrackDuration)
               {
                  var timeArr = vars.CurrentTrackDuration["@val"].split(':');
                  duration =  timeArr[0] * 3600 + timeArr[1] * 60 + timeArr[2] * 1;
                  // Request current position
                  group.parent.InvokeAction("GetPositionInfo", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0}, 
                  function(text)
                  {
                     var xml = new XML(text);
                     try {
                        var response = xml["s:Envelope"]["s:Body"]["u:GetPositionInfoResponse"];
                        //timepast.Text = response.RelTime.toString();
                        var timeArr = response.RelTime.toString().split(':');
                        position =  timeArr[0] * 3600 + timeArr[1] * 60 + timeArr[2] * 1; 
                        timeline.Value = position * 100 / duration;
                     } catch(error) {}
                  });                  
               }
               if(vars.CurrentTrack)
               {
                  if(current > 0 && current <= playlist.ItemsCount) 
                     playlist.CreateItem(current-1, 0, {FillColor: gui.playlistCol0});
                  current = vars.CurrentTrack["@val"];
                  if(current > 0 && current <= playlist.ItemsCount) {
                     playlist.CreateItem(current-1, 0, {FillColor: gui.playlistCol1});
                     // отображение количества песен в плейлисте
                     GetItem(gui.count).Text = current + " of " + playlist_total_count;
                     //playlist.SetPosition(current-1);
                  }
               }
               if(vars["r:EnqueuedTransportURIMetaData"])
               {
                  var xml2 = new XML(vars["r:EnqueuedTransportURIMetaData"]["@val"]);
                  xml2 = xml2["DIDL-Lite"];
                  if(xml2)
                  {                   
                     xml2 = xml2.item;
                     track.Text = xml2["dc:title"];
                     // определять радио другим способом TODO !!!
                     //artist.Text = "Radio";
                  }
               }
               // <TransportStatus val="ERROR_NO_RESOURCE"/>
               // <TransportErrorURI val="x-file-cifs://OKSANA-PC/Music/ACDC%20-%20Back%20In%20Black.mp3"/>
               // <TransportErrorDescription val="5,0,ACDC - Back In Black.mp3,//OKSANA-PC/Music,//OKSANA-PC/Music/ACDC - Back In Black.mp3,"/>
               if(vars["TransportErrorDescription"])
               {
                  IR.GetItem(gui.main_page).ShowPopup(gui.warning_popup);
                  GetItem(gui.warning_msg).Text = "Song " + vars["TransportErrorURI"]["@val"].substr(12) + " not found!";   
               }
            }
            } catch(error) {}	
         }
      }
   }
   
   //---------------------------------------------------------
   // Send action to group
   //---------------------------------------------------------
   function GroupInvokeAction(action, service, args)
   {
      // Parent
      group.parent.InvokeAction(action, service, args);
      
      // Members
      for(var i = 0; i < group.members.length; ++i) 
         group.members[i].InvokeAction(action, service, args);
   } 
   
   //---------------------------------------------------------
   // Save players list
   //---------------------------------------------------------
   function SavePlayers()
   {
      var data = [];
      for(var i = 0; i < players.length; ++i) 
         data[i] = players[i].Name + '~http://' + players[i].Host + ':' + players[i].Port + players[i].DescriptionUrl;
      IR.SetVariable("Global.SonosPlayers", data.join(','));
   }
   
   //---------------------------------------------------------
   // Load players list
   //---------------------------------------------------------
   function LoadPlayers()
   {
      var data = IR.GetVariable("Global.SonosPlayers");
      if(data)
      {
         data = data.split(',');
         // Simulate found device
         for(var i = 0; i < data.length; ++i)
         {
            var player = data[i].split('~');
            FoundDevice(player[0], player[1]);
         }
      }   
   }   
   
   //---------------------------------------------------------
   // Find ui item
   //---------------------------------------------------------
   function GetItem(path)
   {
      path = path.split('.');
      
      // Find parent
      var parent = IR.GetItem(path[0]);
      
      // Find child
      return parent.GetItem(path[1]);
   }
   
   
   //---------------------------------------------------------
   // Every tick loop
   //---------------------------------------------------------
   function Work(time)
   {
      time /= 1000;	// to seconds
      
      if(play.Value)
      {
         {
            // Prediction
            position += time;
            timeline.Value = position * 100 / duration;
            
            // Remaining time
            date.setTime(position * 1000);
            var pasttime = ((duration - position) > 0) ? (duration - position) * 1000 : 0; 
            date2.setTime(pasttime);
            timepast.Text = "-" + date2.getUTCHours() + ((date2.getUTCMinutes() < 10) ? ":0" : ":") + date2.getUTCMinutes() + ((date2.getUTCSeconds() < 10) ? ":0" : ":") + date2.getUTCSeconds();
            timeleft.Text = "" + date.getUTCHours() + ((date.getUTCMinutes() < 10) ? ":0" : ":") + date.getUTCMinutes() + ((date.getUTCSeconds() < 10) ? ":0" : ":") + date.getUTCSeconds();        
         }
      }
   }
   
   /*
      Is someone selected in playlist
   */
   function IsPlayListSelected()
   {
      for(it in playselect)
         if(playselect[it] == 1)
            return true;
            
      return false
   }
   
   /*
      Is someone selected in playlist
   */
   function IsSelected()
   {
      for(it in select)
         if(select[it] == 1)
            return true;
            
      return false
   }
   
   /*
      Show/Hide Group Volume Button
      state = (true/false)
   */ 
   function ToggleOpenVolumeGroup(state)
   {
      GetItem(gui.open_volume_group).Visible = state;
      GetItem(gui.open_volume_group).Enable = state;
   }
   
   /*
      Show/Hide PlayList Delete Button
      state = (true/false)
   */
   function ToggleDeleteButton(state)
   {
      GetItem(gui.deleteb).Visible = state;
      GetItem(gui.deleteb).Enable = state;
   }
   
   /*
      index - selected zone
   */
   function HighLightSelectedZone(index)
   {
      // turn off previous zone
      if(selected_zone != index)
         grouplist.CreateItem(selected_zone, 1, {Value: 0} );      
      // enable selected zone
      grouplist.CreateItem(index, 1, {Value: 1} );
      selected_zone = index;
   }
   
   /*
      Getting player index by player pointer
   */
   function GetPlayerIndex(player)
   {
      for(i in players)
         if(players[i] == player)
            return i;
            
      debug("GetPlayerIndex bad index !!!");
   }

   /*
      Getting group index by player pointer
   */   
   function GetGroupIndex(player)
   {
      for(i in groups)
         if(groups[i].parent == player)
            return i;
   }
   
   function Subscribe(player)
   {
      /*var indx = GetPlayerIndex(player);
      debug("Subscribe " + indx);*/
      player.Subscribe("urn:schemas-upnp-org:service:AVTransport:1");
      player.Subscribe("urn:schemas-upnp-org:service:RenderingControl:1");
      player.Subscribe("urn:schemas-upnp-org:service:ContentDirectory:1");
   }
   
   function UnSubscribe(player)
   {
      /*var indx = GetPlayerIndex(player);
      debug("UnSubscribe " + indx);*/
      player.Unsubscribe("urn:schemas-upnp-org:service:AVTransport:1");
      player.Unsubscribe("urn:schemas-upnp-org:service:RenderingControl:1");
      player.Unsubscribe("urn:schemas-upnp-org:service:ContentDirectory:1");
   }
         
   // debugging functions
   function debug(text)
   { IR.Log("======== " + text); }
   
   function printXMLObject(object)
   {
      debug(">printObject");
      IR.Log(object.printXML());
      debug("<printObject");
   }
   
   function printObject(object)
   {
      debug(">printObject");
      debug(object);
               
      for(key in object)
      {
         IR.Log(key + " " + object[key]);
         if(typeof object[key] == 'object')
             printObject(object[key]);
      }         
      debug("<printObject");
   }
   
   /*
      PlayBack the Stream
   */
   function PlayBack(title, uri, speed)
   {
      var meta = '&lt;DIDL-Lite xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot; ';
      meta += 'xmlns:upnp=&quot;urn:schemas-upnp-org:metadata-1-0/upnp/&quot; ';
      meta += 'xmlns:r=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot; ';
      meta += 'xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&quot;';
      meta += '&gt;&lt;item id=&quot;-1&quot; ';
      meta += 'parentID=&quot;-1&quot; ';
      meta += 'restricted=&quot;true&quot;&gt;';
      meta += '&lt;dc:title&gt;' + title + '&lt;/dc:title&gt;';
      meta += '&lt;upnp:class&gt;object.item.audioItem.audioBroadcast&lt;/upnp:class&gt;';
      meta += '&lt;desc id=&quot;cdudn&quot; ';
      meta += 'nameSpace=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot;&gt;SA_RINCON65031_';
      meta += '&lt;/desc&gt;&lt;/item&gt;&lt;/DIDL-Lite&gt;';
      
      group.parent.InvokeAction("SetAVTransportURI", "urn:schemas-upnp-org:service:AVTransport:1",  
      {InstanceID: 0, CurrentURI: uri, CurrentURIMetaData: meta});
   
      group.parent.InvokeAction("Play", "urn:schemas-upnp-org:service:AVTransport:1", {InstanceID: 0, Speed: speed});
   }
   
   /*
      calc global volume as arithmetic mean
   */
   function CalcGroupVolume(in_group)
   {
      var amean = in_group.parent.player_volume;
      for(var i=0; i < in_group.members.length; i++)
         amean += in_group.members[i].player_volume;

      return Math.round(amean / (in_group.members.length + 1));  
   }

      function GetAverage(vol, inc) 
      {
         return (vol*inc - 100 > 0) ? vol*inc - 100 : 0;
      }
      
      function CalcAverage(in_group, in_inc_mean)
      {
         var aver = GetAverage(in_group.parent.player_volume, in_inc_mean);
         if(aver) return aver;
         
         for(var i=0; i < in_group.members.length; i++)
         {
            aver = GetAverage(in_group.members[i].player_volume, in_inc_mean);
            if(aver) return aver;
         }
         return aver;       
      }
      
      function CalcNewVol(v, inc, aver)
      {
         var nvol = (v) ? v * inc : inc;
         nvol = (nvol > 100) ? 100 : nvol;
         nvol = (nvol < 50 && aver > 5) ? nvol + aver : nvol;
         return nvol;
      }
          
   
   /*
      Form Deezer message
   */
   function FormInvokeAction(method, path, host, action, id)
   {
      var sid = 'fr1PvlmTHL52d3c6d1de34f5Gj7Np4O52d3c6d1de38edSkOQU';
      var uid = '411385351'; //'411385351';
      var body = '<s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/">';
   	body += '<s:Header>';
   	body +=    '<credentials xmlns="http://www.sonos.com/Services/1.1">';
   	body +=       '<sessionId>' + sid + ':0:' + uid + '</sessionId>';
   	body +=       '<deviceId>00-0E-58-3B-37-C2:5</deviceId>';
   	body +=       '<deviceProvider>Sonos</deviceProvider>';
   	body +=    '</credentials>';
   	body += '</s:Header>';
   	body += '<s:Body>';
   	body +=    '<' + action + ' xmlns="http://www.sonos.com/Services/1.1">';
   	body +=       '<id>' + id + '</id>';
   	body +=       '<index>0</index>';
   	body +=       '<count>100</count>';
   	body +=    '</' + action + '>';
   	body += '</s:Body>';
      body += '</s:Envelope>';
      
      var content_length = body.length; 
      
      // create header
      var header = method + " " + path + " HTTP/1.1" + "\r\n";
      header += 'CONNECTION: close\r\n';
      header += 'ACCEPT-ENCODING: gzip\r\n';
      header += 'HOST: ' + host + '\r\n'; //deezer.ws.sonos.com
      header += 'USER-AGENT: Linux UPnP/1.0 Sonos/24.0-69180m (WDCR:Microsoft Windows NT 6.1.7600.0)\r\n';
      header += 'CONTENT-LENGTH: ' + content_length + '\r\n';
      header += 'CONTENT-TYPE: text/xml; charset="utf-8"\r\n';
      header += 'ACCEPT-LANGUAGE: en-US\r\n';
      header += 'SOAPACTION: "http://www.sonos.com/Services/1.1#' + action + '"\r\n'; // getMetadata
      
      var request = header + '\r\n' + body + '\r\n';
      return [request];
   }
};